<Query Kind="Program" />

void Main()
{
    var a0=1;
	var b0= a0+=2;
	Console.WriteLine($"運算式結果:{b0}");//3
	
    var a1 = 0b_1111_0001; //241
	Console.WriteLine($"10進位格式: {Convert.ToString(a1, toBase: 10)}");
	var b1 = a1<<= 8; //a1 左移8位,相當於 a1 乘以 2^8
	//1111 0001 0000 0000
	Console.WriteLine($"位元左移後結果: {Convert.ToString(b1, toBase: 2)}");
	var c1= b1>>=4; //b1 右移4位,相當於 b1 除以 2^4
	//1111 0001 0000
	Console.WriteLine($"位元右移後結果: {Convert.ToString(c1, toBase: 2)}");

    var name ="rico";
	Console.WriteLine(name!=null ? name:"no name"); //rico
	
	int[] numbers = { 2, 3, 4, 5 };
	Console.WriteLine(numbers ?? Array.Empty<int>());//2 3 4 5
	
	if ( numbers  is Array) Console.WriteLine("numbers is array"); //numbers is array
	
	IEnumerable<int> mynumbers = new List<int>(){10, 20, 30};
	IList<int> indexable = mynumbers as IList<int>;
	if (indexable != null)
	{
	    Console.WriteLine(indexable[0] + indexable[indexable.Count - 1]);//40
	}

	var a = uint.MaxValue;
	unchecked
	{
	    Console.WriteLine($"溢位後結果:{a + 2}"); // 1
	}

	try
	{
	    checked
	    {
	        Console.WriteLine(a + 2);
	    }
	}
	catch (OverflowException e)
	{
	    Console.WriteLine($"溢位例外錯誤:{e.Message}"); 
	}

    //字串運算式
	var age = 18;
	var message = $"My age is {age}.";
	Console.WriteLine($"字串運算式:{message}");
	
	//lambda運算式	
	var total = numbers.Sum(x => x);
	Console.WriteLine($"lambda運算式:{total}");
	
	//查詢運算式
	var query =
    from item in numbers
    where item > 3
    orderby item descending
    select item;
	Console.WriteLine($"查詢運算式:{string.Join(",", query)}");
}


